diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/Node.java b/game/core/src/main/java/net/minecraft/core/current/wire/Node.java
new file mode 100644
index 000000000..1159096fc
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/Node.java
@@ -0,0 +1,112 @@
+package net.minecraft.core.current.wire;
+
+import net.minecraft.core.current.util.BlockPos;
+import net.minecraft.core.current.util.BlockState;
+import net.minecraft.core.current.wire.WireHandler.Directions;
+import net.minecraft.core.world.World;
+import net.minecraft.core.block.Blocks;
+
+import java.util.Arrays;
+
+/**
+ * A Node represents a block in the world. It also holds a few other pieces of
+ * information that speed up the calculations in the WireHandler class.
+ *
+ * @author Space Walker
+ */
+public class Node {
+
+	// flags that encode the Node type
+	private static final int CONDUCTOR = 0b01;
+	private static final int SOURCE    = 0b10;
+
+	final World world;
+	final Node[] neighbors;
+
+	BlockPos pos;
+	BlockState state;
+	boolean invalid;
+
+	private int flags;
+
+	/** The previous node in the priority queue. */
+	Node prev_node;
+	/** The next node in the priority queue. */
+	Node next_node;
+	/** The priority with which this node was queued. */
+	int priority;
+	/** The wire that queued this node for an update. */
+	WireNode neighborWire;
+
+	Node(World world) {
+		this.world = world;
+		this.neighbors = new Node[Directions.ALL.length];
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj) {
+			return true;
+		}
+		if (!(obj instanceof Node)) {
+			return false;
+		}
+
+		Node node = (Node)obj;
+
+		return world == node.world && pos.equals(node.pos);
+	}
+
+	@Override
+	public int hashCode() {
+		return pos.hashCode();
+	}
+
+	Node set(BlockPos pos, BlockState state, boolean clearNeighbors) {
+		if (state.is(Blocks.WIRE_REDSTONE)) {
+			throw new IllegalStateException("Cannot update a regular Node to a WireNode!");
+		}
+
+		if (clearNeighbors) {
+			Arrays.fill(neighbors, null);
+		}
+
+		this.pos = pos;
+		this.state = state;
+		this.invalid = false;
+
+		this.flags = 0;
+
+		if (this.state.isConductor()) {
+			this.flags |= CONDUCTOR;
+		}
+		if (this.state.isSignalSource()) {
+			this.flags |= SOURCE;
+		}
+
+		return this;
+	}
+
+	/**
+	 * Determine the priority with which this node should be queued.
+	 */
+	int priority() {
+		return neighborWire.priority;
+	}
+
+	public boolean isWire() {
+		return false;
+	}
+
+	public boolean isConductor() {
+		return (flags & CONDUCTOR) != 0;
+	}
+
+	public boolean isSignalSource() {
+		return (flags & SOURCE) != 0;
+	}
+
+	public WireNode asWire() {
+		throw new UnsupportedOperationException("Not a WireNode!");
+	}
+}
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/PriorityQueue.java b/game/core/src/main/java/net/minecraft/core/current/wire/PriorityQueue.java
new file mode 100644
index 000000000..32000d8b1
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/PriorityQueue.java
@@ -0,0 +1,211 @@
+package net.minecraft.core.current.wire;
+
+import net.minecraft.core.current.util.Redstone;
+
+import java.util.AbstractQueue;
+import java.util.Arrays;
+import java.util.Iterator;
+
+public class PriorityQueue extends AbstractQueue<Node> {
+
+	private static final int OFFSET = -Redstone.SIGNAL_MIN;
+
+	/** The last node for each priority value. */
+	private final Node[] tails;
+
+	private Node head;
+	private Node tail;
+
+	private int size;
+
+	PriorityQueue() {
+		this.tails = new Node[(Redstone.SIGNAL_MAX + OFFSET) + 1];
+	}
+
+	@Override
+	public boolean offer(Node node) {
+		if (node == null) {
+			throw new NullPointerException();
+		}
+
+		int priority = node.priority();
+
+		if (contains(node)) {
+			if (node.priority == priority) {
+				// already queued with this priority; exit
+				return false;
+			} else {
+				// already queued with different priority; move it
+				move(node, priority);
+			}
+		} else {
+			insert(node, priority);
+		}
+
+		return true;
+	}
+
+	@Override
+	public Node poll() {
+		if (head == null) {
+			return null;
+		}
+
+		Node node = head;
+		Node next = node.next_node;
+
+		if (next == null) {
+			clear(); // reset the tails array
+		} else {
+			if (node.priority != next.priority) {
+				// If the head is also a tail, its entry in the array
+				// can be cleared; there is no previous node with the
+				// same priority to take its place.
+				tails[node.priority + OFFSET] = null;
+			}
+
+			node.next_node = null;
+			next.prev_node = null;
+			head = next;
+
+			size--;
+		}
+
+		return node;
+	}
+
+	@Override
+	public Node peek() {
+		return head;
+	}
+
+	@Override
+	public void clear() {
+		for (Node node = head; node != null; ) {
+			Node n = node;
+			node = node.next_node;
+
+			n.prev_node = null;
+			n.next_node = null;
+		}
+
+		Arrays.fill(tails, null);
+
+		head = null;
+		tail = null;
+
+		size = 0;
+	}
+
+	@Override
+	public Iterator<Node> iterator() {
+		throw new UnsupportedOperationException();
+	}
+
+	@Override
+	public int size() {
+		return size;
+	}
+
+	public boolean contains(Node node) {
+		return node == head || node.prev_node != null;
+	}
+
+	private void move(Node node, int priority) {
+		remove(node);
+		insert(node, priority);
+	}
+
+	private void remove(Node node) {
+		Node prev = node.prev_node;
+		Node next = node.next_node;
+
+		if (node == tail || node.priority != next.priority) {
+			// assign a new tail for this node's priority
+			if (node == head || node.priority != prev.priority) {
+				// there is no other node with the same priority; clear
+				tails[node.priority + OFFSET] = null;
+			} else {
+				// the previous node in the queue becomes the tail
+				tails[node.priority + OFFSET] = prev;
+			}
+		}
+
+		if (node == head) {
+			head = next;
+		} else {
+			prev.next_node = next;
+		}
+		if (node == tail) {
+			tail = prev;
+		} else {
+			next.prev_node = prev;
+		}
+
+		node.prev_node = null;
+		node.next_node = null;
+
+		size--;
+	}
+
+	private void insert(Node node, int priority) {
+		node.priority = priority;
+
+		// nodes are sorted by priority (highest to lowest)
+		// nodes with the same priority are ordered FIFO
+		if (head == null) {
+			// first element in this queue \o/
+			head = tail = node;
+		} else if (priority > head.priority) {
+			linkHead(node);
+		} else if (priority <= tail.priority) {
+			linkTail(node);
+		} else {
+			// since the node is neither the head nor the tail
+			// findPrev is guaranteed to find a non-null element
+			linkAfter(findPrev(node), node);
+		}
+
+		tails[priority + OFFSET] = node;
+
+		size++;
+	}
+
+	private void linkHead(Node node) {
+		node.next_node = head;
+		head.prev_node = node;
+		head = node;
+	}
+
+	private void linkTail(Node node) {
+		tail.next_node = node;
+		node.prev_node = tail;
+		tail = node;
+	}
+
+	private void linkAfter(Node prev, Node node) {
+		linkBetween(prev, node, prev.next_node);
+	}
+
+	private void linkBetween(Node prev, Node node, Node next) {
+		prev.next_node = node;
+		node.prev_node = prev;
+
+		node.next_node = next;
+		next.prev_node = node;
+	}
+
+	private Node findPrev(Node node) {
+		Node prev = null;
+
+		for (int i = node.priority + OFFSET; i < tails.length; i++) {
+			prev = tails[i];
+
+			if (prev != null) {
+				break;
+			}
+		}
+
+		return prev;
+	}
+}
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/SimpleQueue.java b/game/core/src/main/java/net/minecraft/core/current/wire/SimpleQueue.java
new file mode 100644
index 000000000..405861d9c
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/SimpleQueue.java
@@ -0,0 +1,112 @@
+package net.minecraft.core.current.wire;
+
+import java.util.AbstractQueue;
+import java.util.Iterator;
+
+public class SimpleQueue extends AbstractQueue<WireNode> {
+
+	private WireNode head;
+	private WireNode tail;
+
+	private int size;
+
+	SimpleQueue() {
+
+	}
+
+	@Override
+	public boolean offer(WireNode node) {
+		if (node == null) {
+			throw new NullPointerException();
+		}
+
+		if (tail == null) {
+			head = tail = node;
+		} else {
+			tail.next_wire = node;
+			tail = node;
+		}
+
+		size++;
+
+		return true;
+	}
+
+	@Override
+	public WireNode poll() {
+		if (head == null) {
+			return null;
+		}
+
+		WireNode node = head;
+		WireNode next = node.next_wire;
+
+		if (next == null) {
+			head = tail = null;
+		} else {
+			node.next_wire = null;
+			head = next;
+		}
+
+		size--;
+
+		return node;
+	}
+
+	@Override
+	public WireNode peek() {
+		return head;
+	}
+
+	@Override
+	public void clear() {
+		for (WireNode node = head; node != null; ) {
+			WireNode n = node;
+			node = node.next_wire;
+
+			n.next_wire = null;
+		}
+
+		head = null;
+		tail = null;
+
+		size = 0;
+	}
+
+	@Override
+	public Iterator<WireNode> iterator() {
+		return new SimpleIterator();
+	}
+
+	@Override
+	public int size() {
+		return size;
+	}
+
+	private class SimpleIterator implements Iterator<WireNode> {
+
+		private WireNode curr;
+		private WireNode next;
+
+		private SimpleIterator() {
+			next = head;
+		}
+
+		@Override
+		public boolean hasNext() {
+			if (next == null && curr != null) {
+				next = curr.next_wire;
+			}
+
+			return next != null;
+		}
+
+		@Override
+		public WireNode next() {
+			curr = next;
+			next = curr.next_wire;
+
+			return curr;
+		}
+	}
+}
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/WireConnection.java b/game/core/src/main/java/net/minecraft/core/current/wire/WireConnection.java
new file mode 100644
index 000000000..86c6fa7bd
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/WireConnection.java
@@ -0,0 +1,30 @@
+package net.minecraft.core.current.wire;
+
+/**
+ * This class represents a connection between some WireNode (the 'owner') and a
+ * neighboring WireNode. Two wires are considered to be connected if power can
+ * flow from one wire to the other (and/or vice versa).
+ * 
+ * @author Space Walker
+ */
+public class WireConnection {
+
+	/** The connected wire. */
+	final WireNode wire;
+	/** Cardinal direction to the connected wire. */
+	final int iDir;
+	/** True if the owner of the connection can provide power to the connected wire. */
+	final boolean offer;
+	/** True if the connected wire can provide power to the owner of the connection. */
+	final boolean accept;
+
+	/** The next connection in the sequence. */
+	WireConnection next;
+
+	WireConnection(WireNode wire, int iDir, boolean offer, boolean accept) {
+		this.wire = wire;
+		this.iDir = iDir;
+		this.offer = offer;
+		this.accept = accept;
+	}
+}
diff --git a/game/core/src/main/java/net/minecraft/core/current/wire/WireConnectionManager.java b/game/core/src/main/java/net/minecraft/core/current/wire/WireConnectionManager.java
new file mode 100644
index 000000000..85f14e5c9
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/current/wire/WireConnectionManager.java
@@ -0,0 +1,136 @@
+package net.minecraft.core.current.wire;
+
+import net.minecraft.core.current.wire.WireHandler.Directions;
+import net.minecraft.core.current.wire.WireHandler.NodeProvider;
+
+import java.util.Arrays;
+import java.util.function.Consumer;
+
+public class WireConnectionManager {
+
+	/** The owner of these connections. */
+	final WireNode owner;
+
+	/** The first connection for each cardinal direction. */
+	private final WireConnection[] heads;
+
+	private WireConnection head;
+	private WireConnection tail;
+
+	/** The total number of connections. */
+	int total;
+
+	/**
+	 * A 4 bit number that encodes which in direction(s) the owner has connections
+	 * to other wires.
+	 */
+	private int flowTotal;
+	/** The direction of flow based connections to other wires. */
+	int iFlowDir;
+
+	WireConnectionManager(WireNode owner) {
+		this.owner = owner;
+
+		this.heads = new WireConnection[Directions.HORIZONTAL.length];
+
+		this.total = 0;
+
+		this.flowTotal = 0;
+		this.iFlowDir = -1;
+	}
+
+	void set(NodeProvider nodes) {
+		if (total > 0) {
+			clear();
+		}
+
+		boolean belowIsConductor = nodes.getNeighbor(owner, Directions.DOWN).isConductor();
+		boolean aboveIsConductor = nodes.getNeighbor(owner, Directions.UP).isConductor();
+
+		for (int iDir = 0; iDir < Directions.HORIZONTAL.length; iDir++) {
+			Node neighbor = nodes.getNeighbor(owner, iDir);
+
+			if (neighbor.isWire()) {
+				add(neighbor.asWire(), iDir, true, true);
+
+				continue;
+			}
+
+			boolean sideIsConductor = neighbor.isConductor();
+
+			if (!sideIsConductor) {
+				Node node = nodes.getNeighbor(neighbor, Directions.DOWN);
+
+				if (node.isWire()) {
+					add(node.asWire(), iDir, belowIsConductor, true);
+				}
+			}
+			if (!aboveIsConductor) {
+				Node node = nodes.getNeighbor(neighbor, Directions.UP);
+
+				if (node.isWire()) {
+					add(node.asWire(), iDir, true, sideIsConductor);
+				}
+			}
+		}
+
+		if (total > 0) {
+			iFlowDir = WireHandler.FLOW_IN_TO_FLOW_OUT[flowTotal];
+		}
+	}
+
+	private void clear() {
+		Arrays.fill(heads, null);
+
+		head = null;
+		tail = null;
+
+		total = 0;
+
+		flowTotal = 0;
+		iFlowDir = -1;
+	}
+
+	private void add(WireNode wire, int iDir, boolean offer, boolean accept) {
+		add(new WireConnection(wire, iDir, offer, accept));
+	}
+
+	private void add(WireConnection connection) {
+		if (head == null) {
+			head = connection;
+			tail = connection;
+		} else {
+			tail.next = connection;
+			tail = connection;
+		}
+
+		total++;
+
+		if (heads[connection.iDir] == null) {
+			heads[connection.iDir] = connection;
+			flowTotal |= (1 << connection.iDir);
+		}
+	}
+
+	/**
+	 * Iterate over all connections. Use this method if the iteration order is not
+	 * important.
+	 */
+	void forEach(Consumer<WireConnection> consumer) {
+		for (WireConnection c = head; c != null; c = c.next) {
+			consumer.accept(c);
+		}
+	}
+
+	/**
+	 * Iterate over all connections. Use this method if the iteration order is
+	 * important.
+	 */
+	void forEach(Consumer<WireConnection> consumer, int iFlowDir) {
+		for (int iDir : WireHandler.CARDINAL_UPDATE_ORDERS[iFlowDir]) {
+			for (WireConnection c = heads[iDir]; c != null && c.iDir == iDir; c = c.next) {
+				consumer.accept(c);
+			}
+		}
+	}
+}
